Subject: Re: Getting SCOPE configuration from DHCP in mixed environment

From: Erik Guttman <[email-masked]>
Date: Fri, 1 Sep 2000 08:09:48 +0200 (MET DST)

Kevin Arnold wrote:

> Thanks for your reply Erik,
> 
> One of the problems we have here at Apple is the lack of static
> configuration.  Basically we are going to be in an all or none scenario as
> far as scope managment is concerned.

I understand - but without allowing any manual configuration of scopes,
you get one big 'default' scope.

If you don't allow manual configuration of scopes, but want to deploy on
a larger scale, you need to either use DHCP or MADCAP.  Discovery of scopes
lists from DAAdverts is useful for UAs, but we decided its a bad idea for
SAs.  That is because we really want SAs to have some *administrative*
configuration - to offer their services where appropriate, not everywhere.

> Users on Mac OS won't ever be changing their configuration files, and we
> don't want to allow users to manage their scopes directly as it will quickly
> lead to chaos (ie MacOS 9.0 and our use of the TCP/IP search domain as a
> scope for registration, on campus you see a weird collection of scopes...)

I understand that its better not to have manual configuration, but it still
might be advisable to have an administrative interface allowing the scope
for a machine to be entered (to override dhcp, for instance, which after
all is centralized; the DHCP administrator may not know about special cases).
This is really important for configuring servers (with SAs).  Servers do
not typically use DHCP for configuration.  In this case, it would be really
useful (for mac based servers) to be able to assign a scope configuration
directly.

> I think the best solution for us is to utilize the DHCP settings in both the
> situation where we are getting our IP Address information from the server as
> well as when the machine has a static address.  I'll also look at the links
> you provided for the madcap solutions and see about supporting that on the
> client side.  (Our DHCP server solution on Mac OS X will support the SLP
> options so it doesn't make sense to write our own madcap server).
>
> Thanks again!

You're welcome.
 
> > From: Erik Guttman <[email-masked]>
> > Date: Thu, 31 Aug 2000 08:57:40 +0200 (MET DST)
> > Subject: Re: Getting SCOPE configuration from DHCP in mixed environment
> > 
> > 
> > Kevin,
> > 
> >> So I have a question about the use of the DHCP options for SCOPE
> >> administration.  Basically, what I envision is that in a network
> environment >> where some users are using DHCP and others have static IP
> addresses (like >> here at Apple), we will have a pseudo managed network
> where all the DHCP >> clients will show up in their proper SCOPEs, but the
> statically configured >> machines (especially servers!) will show up in the
> DEFAULT scope. > 
> > You are missing two important mechanisms.
> > 
> > If you have static configuration for N DAs, you go to the DAs and ask
> > for their scopes.  The combination of their scope lists becomes the
> > SLP agent's scope list.
> > 
> > Use MADCAP [RFC 2730] to request the nested scope option.  MADCAP
> > is like DHCP.  Its a simple protocol which allows the host to send
> > out a GETINFO message and get an ACK with a scope list in it.  The
> > list of scope names becomes the host's scope list.  Creating a full
> > MADCAP server is itself not that big a deal.  Creating one which
> > simply replies to GETINFO requests is trivial.
> > 
> > In the future I think one should use 'nested scopes' in order to
> > define a search order for the client (use the closest scopes first
> > for discovery).  This is discussed in:
> > 
> > http://www.ietf.org/internet-drafts/draft-ietf-malloc-madcap-nest-opt-05.txt
> > 
> > This protocol is in the RFC editor's queue for moving to proposed standard
> > (should appear any day now!)
> > 
> > ------
> > 
> > We discuss the new suggested scope configuration rules in
> > 
> > http://www.ietf.org/internet-drafts/draft-guttman-svrloc-slpv2bis-01.txt
> > 
> > This list has been agreed to by the WG on the mailing list, so it will
> > be in the revised SLPv2 which we will move to draft standard.  I want
> > to emphasize to folks at Apple that the revision to SLPv2 will be *minor.*
> > In particular, the revision will *not* introduce any incompatible changes
> > which would render existing SAs or DAs in need of software upgrades.  It
> > is possible that UAs will issue what is today a legal command and find that
> > these cannot be serviced (and get back an error where today that is not the
> > case).  In that case, UA error handling would have to be upgraded if the
> > UA is to deal gracefully with SAs and DAs with reduced functionality.
> > 
> > ------
> > 
> > The SLPv2bis document scope section follows:
> > 
> > 3.5 Scope Configuration
> > 
> > 3.5.1. Deprecate MANDATORY flags in RFC 2610.
> > 
> > 3.5.2. Use nested scopes in MADCAP [5] for scope config.  SAs
> > and DAs join all groups at the top of each nested scope
> > (address range).  They advertise all scopes by the name
> > received in the MADCAP Nested Scope Option [6].
> > 
> > 3.5.3. The simplified scope configuration list would be in
> > decreasing order of preference
> > Pref   Feature                           Requirement 'mode'
> > 1)    static configuration of scope list  MUST
> > 2)    static configuration of DAs*        MUST
> > 3)    dhcp configuration                  SHOULD
> > 4)    dhcp configuration of DAs*          SHOULD
> > 5)    MADCAP / scope configuration        SHOULD
> > 6)    dynamic discovery (DAAdverts)**     MAY
> > 7)    dynamic discovery (SAAdverts)**     MAY
> > 8)    Use of the scope "default"          MUST
> > 
> > The higher item on the list always takes precedence over the lower
> > items.  If no other configuration is supplied, a SLP Agent is
> > configured with the scope list "default".
> > 
> > * If a scope list is not configured (by through static configuration
> > or DHCP) but a list of DAs is, the SLP Agent MUST unicast a
> > SrvRqst for "service:directory-agent" to each of the DAs on the
> > list.  The SLP Agent is configured with the scope list which is the
> > union of all scopes supported by the DAs which respond with a DAAdvert.
> > If a DA on the configuration list does not respond, the SLP Agent
> > SHOULD try to send it a SrvRqst again periodically (like every 30
> > minutes).  Once a DAAdvert is received, the scope list MAY be
> > expanded and the # of DAs known of by the SLP Agent increases.
> > 
> > **Dynamic discovery of scopes MAY be used by User Agents and
> > MUST NOT be used to configure Service Agent or Directory Agent
> > scope lists.
> > 
> > The problem with the current scope rules is that they are overly
> > complicated.  This is largely due to the 'MANDATORY' bit in the
> > SLPv2 DHCP Option [9].  A clarification of how to do scope rules
> > using the current specifications shows just how hard it is [10].
> > 
> > Further, when SLPv2 was published, the Administrative Scoping BCP
> > [4] was available, but further specifications were not.  Now, with
> > MADCAP and the MADCAP Nested Scope Option it is possible to define
> > specific automatic scope configuration behavior.
> > 
> > 
> > 
> > 
> >> Has there been any discussion about this?  Or was there an assumption made
> >> that even though a machine is has a static address, it should also find
> its >> closest DHCP server and get the options from it?
> > 
> > A machine with a static address might not use DHCP at all.  That's not to
> > say it *couldn't.*  The next version of Sun's SLP implementation will get 
> > SLP options from DHCP to configure agents.
> >
> > Erik
> > 
>